typedef int CVStatus;


#define CV_StsOk                    0
#define CV_StsBackTrace            -1
#define CV_StsError                -2
#define CV_StsInternal             -3
#define CV_StsNoMem                -4
#define CV_StsBadArg               -5
#define CV_StsBadFunc              -6
#define CV_StsNoConv               -7
#define CV_StsAutoTrace            -8

#define CV_HeaderIsNull            -9
#define CV_BadImageSize            -10
#define CV_BadOffset               -11
#define CV_BadDataPtr              -12
#define CV_BadStep                 -13
#define CV_BadModelOrChSeq         -14
#define CV_BadNumChannels          -15
#define CV_BadNumChannel1U         -16
#define CV_BadDepth                -17
#define CV_BadAlphaChannel         -18
#define CV_BadOrder                -19
#define CV_BadOrigin               -20
#define CV_BadAlign                -21
#define CV_BadCallBack             -22
#define CV_BadTileSize             -23
#define CV_BadCOI                  -24
#define CV_BadROISize              -25

#define CV_MaskIsTiled             -26

#define CV_StsNullPtr                -27
#define CV_StsVecLengthErr           -28
#define CV_StsFilterStructContentErr -29
#define CV_StsKernelStructContentErr -30
#define CV_StsFilterOffsetErr        -31


#define CV_StsBadSize                -201
#define CV_StsDivByZero              -202
#define CV_StsInplaceNotSupported    -203
#define CV_StsObjectNotFound         -204
#define CV_StsUnmatchedFormats       -205
#define CV_StsBadFlag                -206
#define CV_StsBadPoint               -207
#define CV_StsBadMask                -208
#define CV_StsUnmatchedSizes         -209
#define CV_StsUnsupportedFormat      -210
#define CV_StsOutOfRange             -211

typedef int ( *CVErrorCallBack) (CVStatus status, const char *func,
                                         const char *context, const char *file,int line);

#define CV_ErrModeLeaf     0
#define CV_ErrModeParent   1
#define CV_ErrModeSilent   2
