#! /usr/bin/env python

from __future__ import generators
from types import *

root = 'cvrest'
pretty_tokenprint = False
use_brackets = False
NLexternalDef = True
separator = '_'

text = file(root + '.data', 'r').read()
text = text[:-3]
text = text.replace('\t', 'TAB')
top = eval(text)

def flatten(top):
    out = []
    n = len(top)-1
    out.append('(%s' % (top[0],))
    for i in range(1, n):
        if type(top[i]) is TupleType:
            out.extend(flatten(top[i]))
        else:
            out.append(top[i])
    if type(top[n]) is TupleType:
        flat = flatten(top[n])
        flat[-1] = flat[-1] + ')'
        out.extend(flat)
    else:
        out.append('%s)' % top[n])
    return out

def special_token(token):
    for word in ('TLMB827', 'TLME561', 'TAB',
           'nl1', 'nl2', 'nl3', 'nl4',
           'SEMI', 'COMMA', 'LPARENS', 'RPARENS', '{', '}'):
        if token.find(word) != -1:
            return True
    return False

def subseqs(flat):
    out = []
    is_tokenprint = False
    for token in flat:
        if token.find('TLMB827') != -1:
            is_tokenprint = True
        if token[0] == '(' or token[-1] == ')' or special_token(token):
            if len(out) > 0:
                yield out
                out = []
            yield [token]
        elif is_tokenprint:
            yield [token]
            is_tokenprint = False
        else:
            out.append(token)

def combine(subseq):
    if len(subseq) == 1:
        token = subseq[0]
        i = 0
        while token[i] == '(':
            i += 1
        n = len(token)
        k = n-1
        while token[k] == ')':
            k -= 1
        k += 1
        token = i *'(' + '"' + token[i:k] + '"' + (n-k)*')'
        return token
    else:
        return '"' + separator.join(subseq) + '"'

def reformat1(all):
    nl1 = "'\"nl1\"', "
    all = all.replace(nl1,   '\n')
    nl2 = "'\"nl2\"', "
    all = all.replace(nl2,   '\n')
    nl3 = "'\"nl3\"', "
    all = all.replace(nl3,   '\n')
    nl4 = "'\"nl4\"', "
    all = all.replace(nl4,   '\n')
    TAB = "'\"TAB\"', "
    all = all.replace(TAB,   '\t')
    return all

def reformat2(all):
    nl1 = "'\"nl1\"'"
    all = all.replace(nl1 + ', ', nl1 + ',\n')
    nl2 = "'\"nl2\"'"
    all = all.replace(nl2 + ', ', nl2 + ',\n')
    nl3 = "'\"nl3\"'"
    all = all.replace(nl3 + ', ', nl3 + ',\n')
    nl4 = "'\"nl4\"'"
    all = all.replace(nl4 + ', ', nl4 + ',\n')
    TAB = "'\"TAB\"'"
    all = all.replace(TAB + ', ', TAB + ',\t')
    return all

flat = flatten(top)
out = []
for subseq in subseqs(flat):
    out.append(combine(subseq))
text = ', '.join(out)
if pretty_tokenprint:
    text = text.replace('("TLMB827", ', '<<')
    text = text.replace(', "TLME561")', '>>')
if use_brackets:
    text = text.replace('(', '[[')
    text = text.replace(')', ']]')
if NLexternalDef:
    text = text.replace('("externalDef"',  '\n("externalDef"')

file(root + '.flat', 'w').write(text)
