include "tools.pyx"

cdef extern from "cvrest_nested.h":
    ctypedef union CvMat_data:
        uchar * ptr
        short * s
        int * i
        float * fl
        double * db

    struct CvEHMM
    struct CvEHMMState
    ctypedef union CvEHMM_u:
        CvEHMMState * state
        CvEHMM * ehmm

    ctypedef struct CvMatND_dim:
        int size
        int step

cdef class TemP__CvMat_data:
    cdef CvMat_data* t

    def __new__(self):
        self.t = <CvMat_data*> PyMem_Malloc(sizeof(CvMat_data))
        if self.t == NULL:
            raise MemoryError
        cdef int LocaLi
        cdef int LocaLj
        self.t.ptr = <uchar *> extract_ptr(ptr)
        self.t.s = <short *> extract_ptr(s)
        self.t.i = <int *> extract_ptr(i)
        self.t.fl = <float *> extract_ptr(fl)
        self.t.db = <double *> extract_ptr(db)

    def __dealloc__(self):
        PyMem_Free(self.t)

    def __getattr__(self, name):
        if name == 'ptr':
            return wrap_ptr(<void*> self.t.ptr, 'uchar')
        if name == 's':
            return wrap_ptr(<void*> self.t.s, 'short')
        if name == 'i':
            return wrap_ptr(<void*> self.t.i, 'int')
        if name == 'fl':
            return wrap_ptr(<void*> self.t.fl, 'float')
        if name == 'db':
            return wrap_ptr(<void*> self.t.db, 'double')
        return object.__getattribute__(self, name)

    def __setattr__(self, name, val):
        if name == 'ptr':
            self.t.ptr = <uchar*> extract_ptr(val)
        elif name == 's':
            self.t.s = <short*> extract_ptr(val)
        elif name == 'i':
            self.t.i = <int*> extract_ptr(val)
        elif name == 'fl':
            self.t.fl = <float*> extract_ptr(val)
        elif name == 'db':
            self.t.db = <double*> extract_ptr(val)
        else:
            object.__setattr__(self, name, val)

    def ToPointer(self):
        # BUG: Maybe need "stars" with one star removed.
        # See example5/test.py for usage.
        return  PyCObject_FromVoidPtrAndDesc(self.t, 'CvMat_data *', NULL)

cdef TemP__CvMat_data_ToC(TemP__PY, void * TemP__ptr):
    (<CvMat_data*> TemP__ptr).ptr = <uchar*> extract_ptr(ptr)
    (<CvMat_data*> TemP__ptr).s = <short*> extract_ptr(s)
    (<CvMat_data*> TemP__ptr).i = <int*> extract_ptr(i)
    (<CvMat_data*> TemP__ptr).fl = <float*> extract_ptr(fl)
    (<CvMat_data*>TemP__ptr).db = <double*> extract_ptr(db)

cdef TemP__CvMat_data_FromC(void * TemP__ptr):
    TemP__PY0 = wrap_ptr(<void*> (<CvMat_data*> TemP__ptr).ptr, 'uchar')
    TemP__PY1 = wrap_ptr(<void*> (<CvMat_data*> TemP__ptr).s, 'short')
    TemP__PY2 = wrap_ptr(<void*> (<CvMat_data*> TemP__ptr).i, 'int')
    TemP__PY3 = wrap_ptr(<void*> (<CvMat_data*> TemP__ptr).fl, 'float')
    TemP__PY4 = wrap_ptr(<void*> (<CvMat_data*> TemP__ptr).db, 'double')
    return TemP__CvMat_data(TemP__PY0, TemP__PY1, TemP__PY2, TemP__PY3, TemP__PY4)

def TemP__CvMat_data_FromOpaquePointer(co):
    cdef CvMat_data* TemP__ptr
    TemP__ptr = <CvMat_data*> extract_ptr(co)
    return TemP__CvMat_data_FromC(TemP__ptr)

cdef class TemP__CvEHMM_u:
    cdef CvEHMM_u* t

    def __new__(self):
        self.t = <CvEHMM_u*> PyMem_Malloc(sizeof(CvEHMM_u))
        if self.t == NULL:
            raise MemoryError
        cdef int LocaLi
        cdef int LocaLj
        self.t.state = <CvEHMMState *> extract_ptr(state)
        self.t.ehmm = <CvEHMM *> extract_ptr(ehmm)

    def __dealloc__(self):
        PyMem_Free(self.t)

    def __getattr__(self, name):
        if name == 'state':
            return wrap_ptr(<void*> self.t.state, 'CvEHMMState')
        if name == 'ehmm':
            return wrap_ptr(<void*> self.t.ehmm, 'CvEHMM')
        return object.__getattribute__(self, name)

    def __setattr__(self, name, val):
        if name == 'state':
            self.t.state = <CvEHMMState*> extract_ptr(val)
        elif name == 'ehmm':
            self.t.ehmm = <CvEHMM*> extract_ptr(val)
        else:
            object.__setattr__(self, name, val)

    def ToPointer(self):
        # BUG: Maybe need "stars" with one star removed.
        # See example5/test.py for usage.
        return  PyCObject_FromVoidPtrAndDesc(self.t, 'CvEHMM_u *', NULL)

cdef TemP__CvEHMM_u_ToC(TemP__PY, void * TemP__ptr):
    (<CvEHMM_u*> TemP__ptr).state = <CvEHMMState*> extract_ptr(state)
    (<CvEHMM_u*> TemP__ptr).ehmm = <CvEHMM*> extract_ptr(ehmm)

cdef TemP__CvEHMM_u_FromC(void * TemP__ptr):
    TemP__PY0 = wrap_ptr(<void*> (<CvEHMM_u*> TemP__ptr).state, 'CvEHMMState')
    TemP__PY1 = wrap_ptr(<void*> (<CvEHMM_u*>TemP__ptr).ehmm, 'CvEHMM')
    return TemP__CvEHMM_u(TemP__PY0, TemP__PY1)

def TemP__CvEHMM_u_FromOpaquePointer(co):
    cdef CvEHMM_u* TemP__ptr
    TemP__ptr = <CvEHMM_u*> extract_ptr(co)
    return TemP__CvEHMM_u_FromC(TemP__ptr)

cdef class TemP__CvMatND_dim:
    cdef CvMatND_dim* t

    def __new__(self, size, step):
        self.t = <CvMatND_dim*> PyMem_Malloc(sizeof(CvMatND_dim))
        if self.t == NULL:
            raise MemoryError
        cdef int LocaLi
        cdef int LocaLj
        self.t.size = size
        self.t.step = step

    def __dealloc__(self):
        PyMem_Free(self.t)

    def __getattr__(self, name):
        if name == 'size':
            return self.t.size
        if name == 'step':
            return self.t.step
        return object.__getattribute__(self, name)

    def __setattr__(self, name, val):
        if name == 'size':
            self.t.size = val
        elif name == 'step':
            self.t.step = val
        else:
            object.__setattr__(self, name, val)

    def ToPointer(self):
        # BUG: Maybe need "stars" with one star removed.
        # See example5/test.py for usage.
        return  PyCObject_FromVoidPtrAndDesc(self.t, 'CvMatND_dim *', NULL)

cdef TemP__CvMatND_dim_ToC(TemP__PY, void * TemP__ptr):
    (<CvMatND_dim*> TemP__ptr).size = TemP__PY.size
    (<CvMatND_dim*> TemP__ptr).step = TemP__PY.step

cdef TemP__CvMatND_dim_FromC(void * TemP__ptr):
    TemP__PY0 = (<CvMatND_dim*> TemP__ptr).size
    TemP__PY1 = (<CvMatND_dim*> TemP__ptr).step
    return TemP__CvMatND_dim(TemP__PY0, TemP__PY1)

def TemP__CvMatND_dim_FromOpaquePointer(co):
    cdef CvMatND_dim* TemP__ptr
    TemP__ptr = <CvMatND_dim*> extract_ptr(co)
    return TemP__CvMatND_dim_FromC(TemP__ptr)
