cdef extern from "tiny.h":
    ctypedef struct c_Tiny "Tiny":
        int iVal

    c_Tiny* create(int i)
    void destroy(c_Tiny* t)
    int c_mult "mult" (c_Tiny *t, int scalar, int shift)

cdef class Tiny:
    cdef c_Tiny* t

    def __new__(self, i):
        self.t = create(i)

    def __dealloc__(self):
        destroy(self.t)

    def mult(self, pair):
        return c_mult(self.t, pair[0], pair[1])

    def __getattr__(self, name):
        if name == 'iVal':
            return self.t.iVal
        return object.__getattribute__(self, name)

    def __setattr__(self, name, val):
        if name == 'iVal':
            self.t.iVal = val
        else:
            object.__setattr__(self, name, val)
